# THis is the main code for clonality plot in Fig 1C
# Author: Alejandro Granados
# California Institute of Technology
# Last test July 2020

nRepeats=100
n.unique=array()
n.unique2=array()
max.N=5
n.cells=10000

clone.distribution.bit = array(0,dim=c(n.cells,nRepeats,max.N))
clone.distribution.trit = array(0,dim=c(n.cells,nRepeats,max.N))

for(i in 1:n.cells){

  for(j in 1:nRepeats){
    #generate the samples
    this.sample.bit = sample(1:2^10,i,replace=T);
    this.sample.trit = sample(1:3^10,i,replace=T)
    #count the number of sinlges, pairs, triaads, etc
    this.sample.bit.table = table(this.sample.bit)
    this.sample.trit.table = table(this.sample.trit)

    for(z in 1:max.N){
      clone.distribution.bit[i,j,z] = (sum(this.sample.bit.table==z)/i) * (1/z)^(z-1)
      clone.distribution.trit[i,j,z] = (sum(this.sample.trit.table==z)/i) * (1/z)^(z-1)

    }
  }
}

#plot the sum of the values (as the total probability of clonality)
pdf(paste(pathPlots,"variationBit_Trit.pdf",sep=""))


par(mfrow=c(2,2))

clone.conf.bit = array()
clone.conf.trit = array()
for(i in 1:n.cells){
  clone.conf.bit[i]=sum(apply(clone.distribution.bit[i,,],2,mean))
  clone.conf.trit[i]=sum(apply(clone.distribution.trit[i,,],2,mean))

}

plot(clone.conf.bit,lwd=2,type="l",cex.lab=1.7,cex.axis=1.7,ylab="clonal confidence",xlab="N cells",ylim=c(0.5,1),
     main="Total probability of clonality",log="x")
lines(clone.conf.trit,lwd=2,col="blue")
abline(h=0.95,lwd=3,lty=2,col="red")
